/* 
   manae --- skimple kana MANA Exchanger
   init.c --- for initializing manae
   Copyright 1998-2002 IWAMA Naozumi
   This file is written in SJIS.
   ̃t@C SJIS ŋLqĂ܂B
*/

#ifndef _INIT_C_
#define _INIT_C_

#include <PalmOS.h>

#include "id.h"
#include "manae.h"
#include "myfunc.h"

// prototypes
// in powerjog.c
void MyPowerJOGChangeState(Boolean enabled);

// in kanjidb.c
Err ManaeReleaseUserCandRec(GlobalPtr g);
Err ManaeReleaseLearnCandRec(GlobalPtr g);
Err ManaeReleaseCandRec(GlobalPtr g);

inline static void DP(const CharPtr s)
{
#ifdef DEBUG
  WinDrawChars(s, StrLen(s), 0, 0);
#endif
  return;
}

Boolean DComplForceEnd(GlobalPtr g)
{
  //  DP("DComplForceEnd");

  if (g->dcP == NULL) {
    if (g->debug >= 3) {
      ErrorPrint("DComplForceEnd: dcP == 0", 0, 0);
    }
    return(false);
  }

  if (ManaeReleaseLearnCandRec(g) != 0) {
    //    ErrorPrintNum(ERRWARNING, 0, 0);
  }

  if (ManaeReleaseCandRec(g) != 0) {
    //    ErrorPrintNum(ERRWARNING, 0, 0);
  }

  if (g->dcP->savedWinH != NULL) {
    //    ViewRestoreBuffer(g->dcP->savedWinH, g);
    g->dcP->savedWinH = NULL;
  }

  if (g->dcP->cands != NULL) {
    MemPtrFree(g->dcP->cands);
    g->dcP->cands = NULL;
  }

  if (MemPtrFree(g->dcP) != 0) {
    ErrorPrint("fatal error", 0, 0);
  }
  g->dcP = NULL;

  // (Re)Start PowerJOG
  MyPowerJOGChangeState(true);
  return(true);
}

static Err PrefsGetDefault(Prefs *pP)
{
  pP->mode = 0;
  pP->guiMode = 0;
  pP->popup = 5;
  pP->nonSkkMode = false;
  pP->thumbTypeMode = false;
  pP->dynamicCompletion = false;
  pP->autoInsertion = false;
  pP->debug = 0;

  pP->henkan = HENKANC;
  pP->kakutei = KAKUTEIC;
  pP->alpha2HiraC = ALPHA2HIRA;
  pP->hira2AlphaC = HIRA2ALPHA;
  pP->hira2KataC = HIRA2KATA;
  pP->hira2ZenC = HIRA2ZEN;
  pP->kata2AlphaC = KATA2ALPHA;
  pP->kata2HiraC = KATA2HIRA;
  pP->kata2ZenC = KATA2ZEN;
  pP->zen2HiraC = ZEN2HIRA;
  
  mystrncpy(&(pP->kuten), "B", 3);
  mystrncpy(&(pP->touten), "A", 3);

  return(errNone);
}


Err KanjiStart(GlobalPtr g)
{

  if ((g->selectedCandH = DmGetRecord(g->manaeDB, MANAESELECTEDCANDINDEX)) 
      == NULL) {
    ErrorPrintHex(DmGetLastErr(), 0, 0);
    ErrDisplay("Error");
    return(DmGetLastErr());
  }

  if ((g->selectedCandP = MemHandleLock(g->selectedCandH)) == NULL) {
    ErrDisplay("Error");
    return(ERR_1);
  }

  if ((g->candsH = DmGetRecord(g->manaeDB, MANAECANDSINDEX))
      == NULL) {
    ErrDisplay("Error");
    return(DmGetLastErr());
  }

  if ((g->candsP = MemHandleLock(g->candsH)) == NULL) {
    ErrDisplay("Error");
    return(ERR_1);
  }
  return(errNone);
}

// Now no error checking!!!!!
Err KanjiEnd(GlobalPtr g)
{
  MemHandleUnlock(g->selectedCandH);
  DmReleaseRecord(g->manaeDB, MANAESELECTEDCANDINDEX, true);
  g->selectedCandH = NULL;
  g->selectedCandP = NULL;

  MemHandleUnlock(g->candsH);
  DmReleaseRecord(g->manaeDB, MANAECANDSINDEX, true);
  g->candsH = NULL;
  g->candsP = NULL;
  return(errNone);
}

Err ManaeLoadPreferences(GlobalPtr g)
{
  VoidHand pH;
  Prefs *pP;

  // Load Preferences.
  if (g->manaeDB != NULL) {
    pH = DmQueryRecord(g->manaeDB, MANAEPREFSINDEX);
    if (pH != NULL) {
      pP = MemHandleLock(pH);
      if (pP != NULL) {
	g->mode = pP->mode;
	g->nonSkkMode =  pP->nonSkkMode;
	g->thumbTypeMode =  pP->thumbTypeMode;
	g->autoInsertion =  pP->autoInsertion;
	g->guiMode = pP->guiMode;
	g->popup = pP->popup;
	g->debug = pP->debug;
	g->dynamicCompletion = pP->dynamicCompletion;
	g->henkan = pP->henkan;
	g->kakutei = pP->kakutei;
	g->alpha2HiraC = pP->alpha2HiraC;
	g->hira2AlphaC = pP->hira2AlphaC;
	g->hira2KataC = pP->hira2KataC;
	g->hira2ZenC = pP->hira2ZenC;
	g->kata2AlphaC = pP->kata2AlphaC;
	g->kata2HiraC = pP->kata2HiraC;
	g->kata2ZenC = pP->kata2ZenC;
	g->zen2HiraC = pP->zen2HiraC;
	MemHandleUnlock(pH);
      }else {
	return(ERR_1);
      }
    } else {
      return(ERR_1);
    }
  } else {
    return(ERR_1);
  }
  return(errNone);
}

static Err ManaeInitGlobal(GlobalPtr g)
{

  // Set versions.
  g->version = VERSION;
  g->dbVersion = DBVERSION;
  FtrGet(sysFtrCreator, sysFtrNumROMVersion, &(g->romVersion));
  FtrGet(sysFtrCreator, sysFtrNumEncoding, &(g->encoding));
  if (ManaeLoadPreferences(g) != errNone) {
    return(ERR_1);
  }
  
  return(errNone);
}

static DmOpenRef ManaeOpenMyself()
{
  DmOpenRef db;

  DP("ManaeOpenMyself");

  // Open myself to access my resources.
  db = DmOpenDatabaseByTypeCreator(MANAEAPPTYPE, CREATOR,
				   dmModeReadOnly);
  ErrFatalDisplayIf(db == NULL,"Cannot open manae resources");
  return(db);
}

static Err ManaeGetResource(GlobalPtr g)
{
  // Get resources
  g->seionH = DmGetResource('tSTR', 1500);
  MemHandleSetOwner(g->seionH, 0);
  g->seionP = MemHandleLock(g->seionH);
  
  g->dakuonH = DmGetResource('tSTR', 1510);
  MemHandleSetOwner(g->dakuonH, 0);
  g->dakuonP = MemHandleLock(g->dakuonH);

  g->youon1H = DmGetResource('tSTR', 1520);
  MemHandleSetOwner(g->youon1H, 0);
  g->youon1P = MemHandleLock(g->youon1H);

  g->youon2H = DmGetResource('tSTR', 1530);
  MemHandleSetOwner(g->youon2H, 0);
  g->youon2P = MemHandleLock(g->youon2H);

  g->kanakigouH = DmGetResource('tSTR', 1540);
  MemHandleSetOwner(g->kanakigouH, 0);
  g->kanakigouP = MemHandleLock(g->kanakigouH);

  g->kigouH = DmGetResource('tSTR', 1550);
  MemHandleSetOwner(g->kigouH, 0);
  g->kigouP = MemHandleLock(g->kigouH);

  return((g->seionP == NULL) |
	 (g->dakuonP == NULL) |
	 (g->youon1P == NULL) |
	 (g->youon2P == NULL) |
	 (g->kanakigouP == NULL) |
	 (g->kigouP == NULL)); // Error true (1)
}

Err ManaeCreateManaeDB()
{
  DmOpenRef manaeDB;
  LocalID manaeDBID;
  UInt index;
  VoidHand tmpH;
  VoidPtr tmpP;
  Err err;

  DP("ManaeCreateManaeDB");

  // if manaDB already exsits, delete it.
  manaeDBID = DmFindDatabase(0, MANAEDBNAME);

  if (manaeDBID) {
    if ((err = DmDeleteDatabase(0, manaeDBID)) != errNone) {
      ErrDisplay("Cannot delete the manaeDB.");
      return(err);
    }
  }

  // create db.
  if ((err = DmCreateDatabase(0, MANAEDBNAME, CREATOR, MANAEDBTYPE, false))
      != errNone) {
    ErrDisplay("Cannot create manae DB.\nPlease stop using manae.");
    return(err);
  }

  if ((manaeDB =
       DmOpenDatabaseByTypeCreator(MANAEDBTYPE, CREATOR, dmModeReadWrite)) 
      == NULL) {
    ErrDisplay("Cannot open manae DB.\nPlease stop using manae.");
    return(ERR_1);
  }

  index = MANAEPREFSINDEX;
  if ((tmpH = MyDmNewRecord(manaeDB, &index, sizeof(Prefs)))
      != NULL) {
    Prefs p;
    tmpP = MemHandleLock(tmpH);
    PrefsGetDefault(&p);
    DmWrite(tmpP, 0, &p, sizeof(Prefs));
    MemHandleUnlock(tmpH);
    DmReleaseRecord(manaeDB, index, true);
  } else {
    ErrDisplay("Cannot new a record.");
    DmCloseDatabase(manaeDB);
    return(ERR_1);
  } 
  
  index = MANAELEARNDICINDEX;
  if ((tmpH = MyDmNewRecord(manaeDB, &index, LEARNDICMAXSIZE))
      != NULL) {
    tmpP = MemHandleLock(tmpH);
    DmSet(tmpP, 0, LEARNDICMAXSIZE, linefeedChr);
    MemHandleUnlock(tmpH);
    DmReleaseRecord(manaeDB, index, true);
  } else {
    ErrDisplay("Cannot new a record.");
    DmCloseDatabase(manaeDB);
    return(ERR_1);
  } 

  index = MANAECANDSINDEX;
  if ((tmpH = MyDmNewRecord(manaeDB, &index, CANDSSIZE))
      != NULL) {
    tmpP = MemHandleLock(tmpH);
    DmSet(tmpP, 0, CANDSSIZE, 0);
    MemHandleUnlock(tmpH);
    DmReleaseRecord(manaeDB, index, true);
  } else {
    ErrDisplay("Cannot new a record.");
    DmCloseDatabase(manaeDB);
    return(ERR_1);
  } 

  index = MANAESELECTEDCANDINDEX;
  if ((tmpH = MyDmNewRecord(manaeDB, &index, KANALEN))
      != NULL) {
    tmpP = MemHandleLock(tmpH);
    DmSet(tmpP, 0, KANALEN, 0);
    MemHandleUnlock(tmpH);
    DmReleaseRecord(manaeDB, index, true);
  } else {
    ErrDisplay("Cannot new a record.");
    DmCloseDatabase(manaeDB);
    return(ERR_1);
  } 

  DmCloseDatabase(manaeDB);

  // set version
  MyDmSetDatabaseVersionByTypeCreator(MANAEDBTYPE, CREATOR, DBVERSION);

  return(errNone);
}

DmOpenRef ManaeOpenManaeDB()
{
  DmOpenRef manaeDB;

  DP("ManaeOpenManaeDB");

  manaeDB = 
    DmOpenDatabaseByTypeCreator(MANAEDBTYPE, CREATOR, 
				dmModeLeaveOpen | dmModeReadWrite);
//				dmModeReadWrite);
//  ErrFatalDisplayIf(manaeDB == NULL, "Cannot open manae db.");
  return(manaeDB);
}


static void ManaeUnlockReleaseResource(GlobalPtr g)
{

  DP("ManaeUnlockReleaseResource");

  // Close resources
  MemHandleUnlock(g->seionH);
  DmReleaseResource(g->seionH);
  MemHandleUnlock(g->dakuonH);
  DmReleaseResource(g->dakuonH);
  MemHandleUnlock(g->youon1H);
  DmReleaseResource(g->youon1H);
  MemHandleUnlock(g->youon2H);
  DmReleaseResource(g->youon2H);
  MemHandleUnlock(g->kanakigouH);
  DmReleaseResource(g->kanakigouH);
  MemHandleUnlock(g->kigouH);
  DmReleaseResource(g->kigouH);

}

static Err ManaeNewGlobal2(GlobalPtr g)
{
  DP("ManaeNewGlobal2");

  g->formerDrawP = NULL;
  g->kanaP = NULL;
  g->okuriP = NULL;
  g->lineBufferP = NULL;

  ErrTry {
    g->formerDrawP = MemPtrNew(KANALEN);
    if (g->formerDrawP == NULL) ErrThrow(1);
    *(g->formerDrawP) = nullChr;
    g->kanaP = MemPtrNew(KANALEN);
    if (g->kanaP == NULL) ErrThrow(2);
    *(g->kanaP) = nullChr;
    g->okuriP = MemPtrNew(KANALEN);
    if (g->okuriP == NULL) ErrThrow(3);
    *(g->okuriP) = nullChr;
    g->lineBufferP = MemPtrNew(KANALEN);
    if (g->lineBufferP == NULL) ErrThrow(4);
    *(g->lineBufferP) = nullChr;
  }

  ErrCatch(inErr) {
    switch (inErr) {
    case 4:
      MemPtrFree(g->okuriP);
      g->okuriP = NULL;

    case 3:
      MemPtrFree(g->kanaP);
      g->kanaP = NULL;

    case 2:
      MemPtrFree(g->formerDrawP);
      g->formerDrawP = MemPtrNew(KANALEN);

    case 1:
    default:
      break;
    }
    DP("ManaeGlobalNew2:Err");
    return(ERR_1);
  } ErrEndCatch

  MemPtrSetOwner(g->formerDrawP, 0);
  MemPtrSetOwner(g->kanaP, 0);
  MemPtrSetOwner(g->okuriP, 0);
  MemPtrSetOwner(g->lineBufferP, 0);

  DP("ManaeGlobalNew2:Finish");
  return(errNone);    
}

static Err ManaeFreeGlobal2(GlobalPtr g)
{
  DP("ManaeFreeGlobal2");

  if (g->formerDrawP != NULL) {
    if (MemPtrFree(g->formerDrawP) == 0){
      g->formerDrawP = NULL;
    }
  }

  if (g->kanaP != NULL) {
    if (MemPtrFree(g->kanaP) == 0){
      g->kanaP = NULL;
    }
  }

  if (g->okuriP != NULL) {
    if (MemPtrFree(g->okuriP) == 0){
      g->okuriP = NULL;
    }
  }

  if (g->lineBufferP != NULL) {
    if (MemPtrFree(g->lineBufferP) == 0){
      g->lineBufferP = NULL;
    }
  }

  if ((g->formerDrawP == NULL) &&
      (g->kanaP == NULL) &&
      (g->okuriP == NULL) &&
      (g->lineBufferP == NULL)) { 
    return(errNone);
  }
  return(ERR_1);
}

static Err ManaeFreeGlobal(GlobalPtr g)
{
  DP("ManaeFreeGlobal");

  if (ManaeFreeGlobal2(g) == errNone) {
    MemPtrFree(g);
    g = NULL;
    return(errNone);
  }
  return(ERR_1);
}

static GlobalPtr ManaeNewGlobal(void)
{
  GlobalPtr g;
  Int i;

  DP("ManaeNewGlobal");
  
  if ((g = MemPtrNew(sizeof(Global))) == NULL) {
    return(NULL); // temporaly.
  }

  // Clear memory.
  for (i = 0; i < sizeof(Global); i++) {
    *((Byte *)g + i) = 0;
  }

  if (ManaeNewGlobal2(g) != errNone) {
    MemPtrFree(g);
    return(NULL);
  }
  
  MemPtrSetOwner(g, 0); // Never Garbage collected.
  // g->lineBuffer[0] = nullChr;
  return(g);
}

static Err ManaeGlobalHealthCheck(GlobalPtr g)
{
  DP("ManaeGlobalHealthCheck");
  return(errNone);
}

static Err ManaeHeapCheck()
{
  MemPtr startP, endP;
  UInt32 free, max, romVersion;

  DP("ManaeHeapCheck");

  FtrGet(sysFtrCreator, sysFtrNumROMVersion, &romVersion);

  if (romVersion >= 0x03500000) {
    if (SysGetStackInfo (&startP, &endP) == false) {
      return(ERR_2);
    } else {
      //      ErrorPrintHex(startP, 0, 0);
      //      ErrorPrintHex(endP, 80, 0);
    }
    MemHeapFreeBytes(0, &free, &max);
    //    ErrorPrintHex(free, 0, 10);
    //    ErrorPrintHex(max, 80, 10);
  }
  return(errNone);
}

GlobalPtr ManaeStart(void)
{
  GlobalPtr g;

  DP("ManaeStart");

  if (FtrGet(CREATOR, FEATUREGLOBAL, (DWordPtr)&g) != 0) { // no such feature
    if (ManaeHeapCheck() != errNone) {
      ErrDisplay("Heap Error");
      return(NULL);
    }
    
    if ((g = ManaeNewGlobal()) == NULL) {
      ErrDisplay("Cannot new globals");
      return(NULL);
    }
    // check manae DB version
    if (MyDmGetDatabaseVersionByTypeCreator(MANAEDBTYPE, CREATOR) <
	DBVERSION) {
      // if there is no manae DB, return 0. 
      if (MyDmDeleteDatabaseByTypeCreator(MANAEDBTYPE, CREATOR) == 0) {
	WinDrawChars("manae deleted manaeDB", 
		     StrLen("manae deleted manaeDB"), 0, 0);
      }
    }
      
    if ((g->manaeDB = ManaeOpenManaeDB()) == NULL) {
      // manae DB does not exist.
      // create manae db and records.
      if (ManaeCreateManaeDB() != errNone) {
	// Cannot create manae DB.
	ErrDisplay("Cannot create a manae DB.");
	ManaeFreeGlobal(g);
	return(NULL);
      }
      if ((g->manaeDB = ManaeOpenManaeDB()) == NULL) {
	ErrDisplay("Cannot open manae DB.");
	ManaeFreeGlobal(g);
	return(NULL);
      }
    }
    // Set globals
    ManaeInitGlobal(g);

    // Get Resources.
    g->db = ManaeOpenMyself();    
    /***** It's illegal!!!!!!!! ****/
    /***** But it works... *********/
    ManaeGetResource(g);
    ManaeUnlockReleaseResource(g);
    if (g->db) DmCloseDatabase(g->db);
    g->db = NULL;
    /*******************************/

    FtrSet(CREATOR, FEATUREGLOBAL, (DWord)g);

    KanjiStart(g);

  } else {
    // already exist feature
    if (ManaeGlobalHealthCheck(g) != errNone) {
      ErrDisplay("Something is wrong(?).\nStop using manae.");
    }
  }
  g->frm = FrmGetActiveForm();
  return(g);
}

Err ManaeStop(GlobalPtr g)
{
  DP("ManaeStop");
  if (g->dcP != NULL) {
      DComplForceEnd(g);
  }
  KanjiEnd(g);
  DmCloseDatabase(g->manaeDB);
  //  ManaeUnlockReleaseResource(g);
  //  ManaeCloseMyself(g);
  
  ManaeFreeGlobal(g);
  return(FtrUnregister(CREATOR, FEATUREGLOBAL));
}

#endif
