/* 
   manae --- skimple kana MANA Exchanger
   kanji.c --- manae's kana mana conversion module
   Copyright 1998-2002 IWAMA Naozumi
   This file is written in SJIS.
   ̃t@C SJIS ŋLqĂ܂B
*/

#ifndef _KANJI_C_
#define _KANJI_C_

#include <PalmOS.h>
#include "id.h"
#include "manae.h"
#include "myfunc.h"

// in manae.c
void InsertToMainField2(CharPtr s, GlobalPtr g);
Char KanaeConvert(CharPtr out, Char c, GlobalPtr g);
Boolean ManaeSetKanaMode(GlobalPtr g);
Boolean ManaeSetMode(Char c, GlobalPtr g);
Boolean isupper(Char c);
Boolean islower(Char c);
Boolean isconsonant(Char c);
CharPtr mystrncpy(CharPtr d, const Char* s, Word n);
Int addChar(CharPtr str, Char c);

// in kanjidb.c
VoidHand ManaeGetCandRec(GlobalPtr g);
Err ManaeReleaseCandRec(GlobalPtr g);
VoidHand ManaeGetUserCandRec(GlobalPtr g);
Err ManaeReleaseUserCandRec(GlobalPtr g);
VoidHand ManaeGetLearnCandRec(GlobalPtr g);
Err ManaeReleaseLearnCandRec(GlobalPtr g);


// in cands.c
Boolean CandsFormHandleEvent (EventPtr event);
Boolean CandsMakeCandsList(CharPtr kana, Char okuriC, CharPtr okuri, 
			  GlobalPtr g);

// completion2.c
Boolean DComplStart(GlobalPtr g);
Boolean DComplEnd(GlobalPtr g);
//Int DComplGetACandLearn(CharPtr yomiP, Int start, VoidPtr dicP,
//			ULong dicLen);
Int DComplGetCands(CharPtr yomiP, GlobalPtr g);
Boolean DComplShow(GlobalPtr g);
Boolean DComplSelectCand(CharPtr yomiP, CharPtr kanjiP,
			 EventPtr eventP, GlobalPtr g);



Boolean CandsSetButton(GlobalPtr g);

Boolean LearnWriteCand(CharPtr convertedP,
		       CharPtr kanaP,
		       Char okuriC, CharPtr okuriP,
		       GlobalPtr g);


Boolean ComplMakeCandList(CharPtr distP, ULongPtr distOffset, 
		       CharPtr kana, GlobalPtr g);
Boolean AddLineBuffer(CharPtr out, GlobalPtr g);
static Boolean ManaeKanjiHenkanMode(Char c, CharPtr insertStr, CharPtr showStr,
				    GlobalPtr g);


// This function works well in ASCII and SJIS.

CharPtr searchStr(CharPtr target, CharPtr domain, ULong len,
		  Char sep, Char stopC)
{
  Int j, k;

  for (j = k = 0; k < len; k++) {
    if ((domain[k] == sep) || (domain[k] == stopC)) {
      j = 0;
    } else {
      if (j >= 0) {
	j = (domain[k] == target[j]) ? (j + 1) : -1;
	if ((target[j] == nullChr)) {
	  if ((k == (len - 1)) ||
	      (domain[k + 1] == sep) ||
	      (domain[k + 1] == stopC)) {
	    return(&domain[k] - j + 1);
	  }
	}
      }
    }
  }
  return(NULL);
}


static CharPtr strcpyplus(CharPtr dist, CharPtr source, Char sep1, Char sep2, Char sep3)
{
  Int i;

  for (i = 0;
       ((source[i] != sep1) && (source[i] != sep2) && 
	(source[i] != sep3) && (source[i] != nullChr) &&
	(i < KANALEN - 1)); 
       i++) {
    dist[i] = source[i];
  }
  dist[i] = nullChr;
  return(dist);
}

// drawing 

Boolean ManaeDrawChars(CharPtr str, UInt len, Short x, Short y, GlobalPtr g)
{
  Short leftEdge, rightEdge;
  Int charWidth;
  Int charsWidth;


  // check start x cordinate. 
  leftEdge = g->fld->rect.topLeft.x;
  rightEdge = g->fld->rect.topLeft.x + g->fld->rect.extent.x;
  g->kanjiStartX = x;
  g->kanjiStartY = y;

  charWidth = FntCharsWidth("", 2);
  charsWidth = (charWidth * len) / 2;

  if ((g->kanjiStartX + charsWidth) > rightEdge) {
    g->kanjiStartX = rightEdge - charsWidth;
    if (g->kanjiStartX < leftEdge) {
      g->kanjiStartX = leftEdge;
      len = (rightEdge - leftEdge) * 2 / charWidth;
    }
  }
  WinDrawChars(str, len, g->kanjiStartX, g->kanjiStartY);
  {
    Int charHeight;

    charHeight = FntCharHeight();
    WinDrawGrayLine(g->kanjiStartX + 3,
		    g->kanjiStartY - 1 + charHeight, 
		    g->kanjiStartX - 1 + charsWidth,
		    g->kanjiStartY - 1 + charHeight);
  }
  return(true);
}

// this function work well on ASCII and SJIS. 
CharPtr GetNextChar(CharPtr source, Char sep, Char stopC)
{
  Int i;

  for (i = 0; ((source[i] != nullChr) &&
	       (source[i] != crChr) &&
	       (source[i] != linefeedChr) &&
	       (source[i] != stopC)); i++) {
    if (source[i] == sep) {
      return(&(source[i]));
    }
    if (source[i] < 0x00) i++; // skip 2Byte Char
  }
  return(NULL);
}

// This function works well on ASCII and SJIS. 
static CharPtr GetPrevChar(CharPtr source, Char sep, CharPtr boundary)
{
  Int i;

  for (i = 0; (source - i) >= boundary; i++) {
    if (*(source - i) == sep){
      return(source - i);
    }
  }
  return(NULL); // This is awfull.
}

static Boolean ManaeGetCand2(CharPtr out, Int direction, GlobalPtr g)
{
  Boolean ret;
  CharPtr ptr;

  ret = false;
  out[0] = nullChr;

  if (! ManaeGetCandRec(g)) {
    //
  } else {
    // no need g->dicType |= JOSDIC;
  }

  if (! ManaeGetUserCandRec(g)) {
    //
  } else {
    // no need g->dicType |= USERDIC;
  }

  if (! ManaeGetLearnCandRec(g)) {
    //
  } else {
    // no need g->dicType |= LEARNDIC;
  }

  if (g->numOfCand == 0) { // first time
    g->numOfCand = 0;
    g->candNum = 0;
    g->candsOffset = 0;
    g->userCandsOffset = 0;
    g->currCandOffset = 0;
   
    if (!CandsMakeCandsList(g->kanaP, g->okuriC, g->okuriP, g)) {
      out[0] = nullChr;
      ManaeReleaseCandRec(g);
      ManaeReleaseLearnCandRec(g); // We must release learning dic.
      // before user dic.
      ManaeReleaseUserCandRec(g);
      return(false);
    }      
    g->numOfCand = 1;
  }

  if (g->dicType == 0) { // no dictionary
    out[0] = nullChr;
    ManaeReleaseCandRec(g);
    ManaeReleaseLearnCandRec(g); // We must release learning dic. before user dic.
    ManaeReleaseUserCandRec(g);
    return(false);
  }

  switch (direction) {
  case -1 :
    g->candNum--;

    if ((ptr = GetPrevChar(g->candsP + g->currCandOffset - 2, '/',
			   g->candsP))
	!= NULL) {
      ptr++; // skip '/'
      strcpyplus(out, ptr, '/', 0x0d, linefeedChr);
      g->currCandOffset = (Int)(ptr - g->candsP);
      ret = true;
    } else {
      // no cand
      ret = false;
    }
    break;

  case 0:
    strcpyplus(out, g->candsP + g->currCandOffset, '/', 0x0d, linefeedChr);
    ret = true;
    break;

  case 1:
  default:
    g->candNum++;
    if ((ptr = GetNextChar(g->candsP + g->currCandOffset, '/', 0x0d))
	!= NULL) {
      ptr++; // skip '/'
      strcpyplus(out, ptr, '/', 0x0d, linefeedChr);
      g->currCandOffset = (Int)(ptr - g->candsP);
      ret = true;
    } else {
      // no cand
      ret = false;
    }
  }

  ManaeReleaseCandRec(g);
  ManaeReleaseLearnCandRec(g); // We must release learning dic. before user dic.
  ManaeReleaseUserCandRec(g);

  return(ret);
}

static Boolean isHirakana(CharPtr srcP)
{
  Int i;
  WordPtr srcWP;

  srcWP = (WordPtr)srcP;

  
  for (i = 0; ((srcWP[i] & 0xff00) != 0); i++) {
    if ((srcWP[i] < 0x829f) || (srcWP[i] > 0x82f1)) return(false);
    if (srcP[i * 2 + 1] == nullChr) break;
  }
  return(true);
}

// check selection
// for selected word conversion
Boolean ManaeCheckSelection(EventPtr event, GlobalPtr g)
{
  //  Char out[KANALEN], t[KANALEN];
  Word startPos, endPos;

  if (event->data.keyDown.chr == ' ') {
    FldGetSelection(g->fld, &startPos, &endPos);
    if (startPos < endPos) {
      //      Char kanaP[KANALEN * 2];
      CharPtr out, t, kanaP, srcP;

      kanaP = MemPtrNew(KANALEN * 2);
      if (kanaP == NULL) {
	//	ErrorPrint("manae:ManaeCheckSelection: fatal error", 0, 0);
	return(false);
      }
      kanaP[0] = nullChr;

      srcP = FldGetTextPtr(g->fld);
      mystrncpy(kanaP, srcP + startPos,
		((endPos - startPos) < (KANALEN - 2)) ? 
		endPos - startPos : KANALEN - 2);

      if (!isHirakana(kanaP)) {
	FldSetSelection(g->fld, startPos, endPos);
	MemPtrFree(kanaP);
	return(true);
      }
      
      // flush line buffer.
      g->flush = true;

      out = MemPtrNew(KANALEN);
      if (out == NULL) {
	//	ErrorPrint("manae:ManaeCheckSelection: fatal error", 0, 0);
	return(false);
      }
      out[0] = nullChr;
      AddLineBuffer(out, g);

      MemPtrFree(out);

      MyInsPtGetLocation(&(g->insPtX), &(g->insPtY));
      WinDisplayToWindowPt(&(g->insPtX), &(g->insPtY));
      g->kanjiMode = KANJI;
      g->kanjiStartX = g->insPtX;
      g->kanjiStartY = g->insPtY;
      g->candNum = 0;
      g->numOfCand = 0;
      g->candsOffset = 0;
      g->currCandOffset = 0;
      g->okuriC = nullChr;
      g->dicType = 0;
      g->currDicType = 0;

      t = MemPtrNew(KANALEN);
      if (t == NULL) {
	//	ErrorPrint("manae:ManaeCheckSelection: fatal error", 0, 0);
	return(false);
      }
      t[0] = nullChr;

      StrCopy(t, HENKANCHR);
      StrCat(t, kanaP);
      mystrncpy(g->kanaP, t + StrLen(HENKANCHR), 
		StrLen(t) - StrLen(HENKANCHR) + 1);

      g->consonant = nullChr;
      g->consonant1 = nullChr;
      g->consonant2 = nullChr;
      g->consonant3 = nullChr;

      *(g->okuriP) = nullChr;
      mystrncpy(g->formerDrawP, t, StrLen(t) + 1);
      ManaeDrawChars(t, StrLen(t), g->kanjiStartX, g->kanjiStartY, g);

      MemPtrFree(t);

      g->insPtX = g->kanjiStartX;
      g->insPtY = g->kanjiStartY;
      EvtAddEventToQueue(event);

      MemPtrFree(kanaP);

      return(true);
    }
  }
  return(false);
}

Boolean ManaeCheckStartKanji(EventPtr event, GlobalPtr g)
{
  //  Char out[KANALEN], t[KANALEN];
  CharPtr out;
  //  Word startPos, endPos;

  if (event->eType != keyDownEvent) {
    return(false); // currently 
  }

  if (g->mode == ALPHA) {
    return(false);
  }

  if (ManaeCheckSelection(event, g)) {
    return(true);
  }

  out = MemPtrNew(KANALEN);
  if (out == NULL) {
    //    ErrorPrint("manae:ManaeCheckStartKanji: fatal error", 0, 0);
    return(false);
  }
  
  if (((g->nonSkkMode) && 
       ((isupper(event->data.keyDown.chr) ||
	 islower(event->data.keyDown.chr)) &&
	(g->mode == HIRA) &&
	(event->data.keyDown.chr != 'q') &&
	(event->data.keyDown.chr != 'L') &&
	(event->data.keyDown.chr != 'l'))) ||
      (!(g->nonSkkMode) &&
       ((isupper(event->data.keyDown.chr) ||
	 isJogUp(event->data.keyDown.chr)) &&
	(g->mode == HIRA) &&
	(event->data.keyDown.chr != 'L'))) ||
      (event->data.keyDown.chr == 'Q')) {

    // flush line buffer.
    g->flush = true;
    out[0] = nullChr;
    out[1] = nullChr;
    AddLineBuffer(out, g);

    //    InsPtGetLocation(&(g->insPtX), &(g->insPtY));
    MyInsPtGetLocation(&(g->insPtX), &(g->insPtY));
    WinDisplayToWindowPt(&(g->insPtX), &(g->insPtY));
    g->kanjiMode = KANJI;
    g->kanjiStartX = g->insPtX;
    g->kanjiStartY = g->insPtY;
    g->candNum = 0;
    g->numOfCand = 0;
    g->candsOffset = 0;
    g->currCandOffset = 0;
    g->okuriC = nullChr;
    g->dicType = 0;
    g->currDicType = 0;

    DComplStart(g);

    if (KanaeConvert(out, event->data.keyDown.chr, g) ||
	isJogUp(event->data.keyDown.chr) ||
	(event->data.keyDown.chr == 'Q')) {
      CharPtr t;
      
      t = MemPtrNew(KANALEN);
      if (t == NULL) {
	if (out != NULL) { 
	  MemPtrFree(out);
	}
	//	ErrorPrint("manae:ManaeCheckSelection: fatal error", 0, 0);
	return(false);
      }

      StrCopy(t, HENKANCHR);
      StrCat(t, g->kanaP);
      StrCat(t, out);
      //      DmWrite(g->kanaP, 0, t + StrLen(HENKANCHR), 
      //	      StrLen(t) - StrLen(HENKANCHR) + 1);
      mystrncpy(g->kanaP, t + StrLen(HENKANCHR), 
		StrLen(t) - StrLen(HENKANCHR) + 1);

      StrCat(t, &g->consonant);
      //      DmWrite(g->formerDrawP, 0, t, StrLen(t) + 1);
      mystrncpy(g->formerDrawP, t, StrLen(t) + 1);
      ManaeDrawChars(t, StrLen(t), g->kanjiStartX, g->kanjiStartY, g);

      MemPtrFree(t);

      g->insPtX = g->kanjiStartX;
      g->insPtY = g->kanjiStartY;
      if (out[1] != nullChr) {
	//	WinDrawChars(out, StrLen(out), 140, 0);
	DComplGetCands(g->kanaP, g);
	DComplShow(g);
      }
    }
    MemPtrFree(out);
    //    KanjiStart(g);
    return(true);
  }
  MemPtrFree(out);
  return(false);
}

static Boolean isHenkan(Char c, GlobalPtr g)
{
  return(((c == g->henkan) || (c == spaceChr) || (c == pageDownChr) ||
	  (isJogDown(g->event->data.keyDown.chr))) ?
	 true : false);
} 

static Boolean isPrev(Char c, GlobalPtr g)
{
  return(((c == 'x') || (c == pageUpChr) ||
	  (isJogUp(g->event->data.keyDown.chr))) ?
	 true : false);
} 

Boolean isKakutei(Char c, GlobalPtr g)
{
  return(((c == g->kakutei) || (c == '\\') ||
	  (c == g->hira2AlphaC) ||
	  (c == g->hira2ZenC) ||
	  (isJogRelease(g->event->data.keyDown.chr))) ?
	 true : false);
}

static Boolean isHokan(Char c, GlobalPtr g)
{
  return(((c == '.') || (c == ('i' - 'a' + 1)) ||
	  isJogUp(g->event->data.keyDown.chr)) ? true : false);
}

static Boolean isHira2Kata(Char c, GlobalPtr g)
{
  return(c == g->hira2KataC);
}

static Boolean ManaeKanjiOkuriMode(Char c, CharPtr insertStr, CharPtr showStr,
			    GlobalPtr g)
{
  Char out[16];

  insertStr[0] = showStr[0] = nullChr; 

  if (isKakutei(c, g)) {
    //    DmSet(g->formerDrawP, 0, 2, nullChr);
    *(g->formerDrawP) = nullChr;
    StrCopy(insertStr, g->kanaP);
    g->candNum = g->numOfCand = 0;
    g->candsOffset = g->currCandOffset = g->okuriC =0;
    ManaeSetMode(c, g);
    //    KanjiEnd(g);
    return(true);
  }

  if (c == backspaceChr) {
    KanaeConvert(out, c, g); // flash consonant buffer
    g->kanjiMode = KANJI;
    g->candNum = 0;
    g->numOfCand = 0;
    g->candsOffset = 0;
    g->currCandOffset = 0;
    StrCopy(showStr, HENKANCHR);
    StrCat(showStr, g->kanaP);
    //    DmWrite(g->kanaP, 0, showStr + StrLen(HENKANCHR), 
    //	    StrLen(showStr) - StrLen(HENKANCHR) + 1);
    mystrncpy(g->kanaP, showStr + StrLen(HENKANCHR), 
	      StrLen(showStr) - StrLen(HENKANCHR) + 1);


    g->okuriC =0;
    return(true);
  }

  // for PEG
  if (g->okuriC == nullChr) {
    g->okuriC = g->consonant;
  }

  if (KanaeConvert(out, c, g)) {
    if ((out[0] != nullChr) && (g->consonant == nullChr)) {
      // kana decided
      g->kanjiMode = HENKAN;
      StrCopy(showStr, g->okuriP);
      StrCat(showStr, out);
      //      DmWrite(g->okuriP, 0, showStr, StrLen(showStr) + 1);
      mystrncpy(g->okuriP, showStr, StrLen(showStr) + 1);
      StrCopy(showStr, KOHOCHR);

      // close dynamic completion
      DComplEnd(g);

      if (ManaeGetCand2(showStr + StrLen(KOHOCHR), +1, g)) {
	// find cand.
	g->kanjiMode = HENKAN;
      } else {
	g->okuriC = nullChr;
	if (ManaeKanjiHenkanMode(g->henkan, insertStr, showStr, g)) {
	  return(true);
	}
	g->kanjiMode = KANJI;
	g->candNum = 0;
	g->numOfCand = 0;
	g->candsOffset = 0;
	g->currCandOffset = 0;
	StrCopy(showStr, HENKANCHR);
	StrCat(showStr, g->kanaP);
	StrCat(showStr, "*");
      StrCat(showStr, g->okuriP);

      }
      return(true);
    }
  }
  g->kanjiMode = OKURIIN;
  //  DmWrite(g->okuriP, StrLen(g->okuriP), out, StrLen(out) + 1);
  mystrncpy(g->okuriP + StrLen(g->okuriP), out, StrLen(out) + 1);
  StrCopy(showStr, HENKANCHR);
  StrCat(showStr, g->kanaP);
  StrCat(showStr, "*");
  StrCat(showStr, g->okuriP);
  StrCat(showStr, &g->consonant);
  return(true);
}

static Boolean ManaeKanjiOkuriStart(Char c, CharPtr insertStr, CharPtr showStr,
				    GlobalPtr g)
{
  Int i;
  Char out[16];

  if (!isupper(c)) {
    out[0] = nullChr;
    return(false);
  }

  out[0] = nullChr;
  c = c - 'A' + 'a';
  
  if (isconsonant(c)) {
    if (KanaeConvert(out, c, g)) {
      i = StrLen(g->kanaP);
      //      DmWrite(g->kanaP, i, out, StrLen(out) + 1);
      mystrncpy(g->kanaP + i, out, StrLen(out) + 1);
    }
    g->consonant = nullChr;
    g->consonant1 = nullChr;
    g->consonant2 = nullChr;
    g->consonant3 = nullChr;

  }
  g->okuriC = (g->consonant == nullChr) ? c : g->consonant;
  return(ManaeKanjiOkuriMode(c, insertStr, showStr, g));
}

static Boolean ManaeKanjiOkuriStartJog(CharPtr insertStr,
				       CharPtr showStr,
				       GlobalPtr g)
{
  Int i;
  Char out[8];

  if (KanaeConvert(out, 0, g)) {
    i = StrLen(g->kanaP);
    //    DmWrite(g->kanaP, i, out, StrLen(out) + 1);
    mystrncpy(g->kanaP + i, out, StrLen(out) + 1);
  }
  g->consonant = nullChr;
  g->consonant1 = nullChr;
  g->consonant2 = nullChr;
  g->consonant3 = nullChr;
  g->okuriC = nullChr;

  g->kanjiMode = OKURIIN;
  //  DmWrite(g->okuriP, StrLen(g->okuriP), out, StrLen(out) + 1);
  StrCopy(showStr, HENKANCHR);
  StrCat(showStr, g->kanaP);
  StrCat(showStr, "*");
  //  StrCat(showStr, g->okuriP);
  //  StrCat(showStr, &g->consonant);
  return(true);
}


static Boolean Hira2Kata(WordPtr distP, Word src)
{
  Boolean ret;
  ret = true;

  if (src < 0x829f) {
    *distP = src;
    ret = false;
  } else {
    if (src <= 0x82dd){
      *distP = src - 0x829f + 0x8340;
    } else {
      if (src <= 0x82f1) {
	*distP = src - 0x82de + 0x8380;
      } else {
	*distP = src;
	ret = false;
      }
    }
  }
  return(ret);
}

static Boolean ManaeHira2Kata(CharPtr distP, CharPtr srcP)
{
  WordPtr distWP, srcWP;
  Int i;
  Boolean ret;

  distWP = (WordPtr)distP;
  srcWP = (WordPtr)srcP;
  ret = true;
  for (i = 0; srcP[i * 2] != nullChr; i++) {
    ret = (Hira2Kata(&distWP[i], srcWP[i])) ? ret : false;
  }
  distP[i * 2] = nullChr;
  return(ret);
}

static Boolean ManaeKanjiKanjiMode(Char c, CharPtr insertStr, CharPtr showStr,
			    GlobalPtr g)
{
  //  Char out[16];

  CharPtr outP;
  Int kanaLen;
  CharPtr yomiP;

  insertStr[0] = showStr[0] = nullChr; 

  // hira -> kata
  if (isHira2Kata(c, g)) {
    outP = MemPtrNew(16);
    //    DmSet(g->formerDrawP, 0, 2, nullChr);
    *(g->formerDrawP) = nullChr;
    *outP = nullChr;
    KanaeConvert(outP, nullChr, g);

    /*
    if (g->consonant == 'n') {
      *outP = 0x83;
      *(outP + 1) = 0x93;
      *(outP + 2) = nullChr;
    } else {
      *outP = nullChr;
    }
    */
    StrCopy(insertStr, g->kanaP);
    MyStrCat(insertStr, outP);    
    ManaeHira2Kata(insertStr, insertStr);

    MemPtrFree(outP);
    
    DComplEnd(g);

    if (insertStr[0] != nullChr) {
      LearnWriteCand(insertStr, g->kanaP, nullChr, NULL, g);
    }
    g->candNum = g->numOfCand = 0;
    g->candsOffset = g->currCandOffset = g->okuriC =0;
    ManaeSetKanaMode(g);
    return(true);
  }

  // Select a dynamic completion candidate.
  yomiP = MemPtrNew(KANALEN);
  if (yomiP == NULL) {
    //    ErrorPrint("manae:ManaeKanjiKanjiMode: fatal error", 0, 0);
    return(false);
  }
  yomiP[0] = nullChr;
  if (g->dcP == NULL) { // if Dynamic Completion have finished.
    DComplStart(g);
  }
  if (DComplSelectCand(yomiP, insertStr, g->event, g)) {
    //    DmSet(g->formerDrawP, 0, 2, nullChr);
    *(g->formerDrawP) = nullChr;
    // close dynamic completion
    DComplEnd(g);

    LearnWriteCand(insertStr, yomiP, nullChr, NULL, g);
    g->candNum = g->numOfCand = 0;
    g->candsOffset = g->currCandOffset = g->okuriC =0;
    ManaeSetMode(c, g);
    MemPtrFree(yomiP);
    //    KanjiEnd(g);
    return(true);
  }
  MemPtrFree(yomiP);

  // Completion
  if (isHokan(c, g) && (g->kanaP[0] != nullChr)) {
    ULong tmpOffset;

    tmpOffset = 0;

    // close dynamic completion
    DComplEnd(g);


    // flush kana buffer
    StrCopy(showStr, g->kanaP);
    KanaeConvert(insertStr, nullChr, g);
    StrCat(showStr, insertStr);
    //    DmWrite(g->kanaP, 0, showStr, StrLen(showStr) + 1);
    mystrncpy(g->kanaP, showStr, StrLen(showStr) + 1);

    insertStr[0] = nullChr;

    if (ComplMakeCandList(g->candsP, &tmpOffset, g->kanaP, g)){
      g->candsOffset = (int)tmpOffset;
      g->kanjiMode = HENKAN;
      g->complFlag = 1;
      g->candsFrmFlg = true;

      if (FtrSet(CREATOR, FEATURECANDSPAGE, 0x1000)) {
	//	FrmCustomAlert(Alert, "kanji.c", "ManaeKanjiHenkanMode()", 
	//		       "Can't set Feature");
      }
      return(true);
    } else {
      g->kanjiMode = KANJI;
      g->candNum = 0;
      g->numOfCand = 0;
      g->candsOffset = 0;
      g->userCandsOffset = 0;
      g->currCandOffset = 0;
      StrCopy(showStr, HENKANCHR);
      StrCat(showStr, g->kanaP);
      if (g->okuriP[0] != nullChr) {
	StrCat(showStr, "*");
	StrCat(showStr, g->okuriP);
      }
    }
    return(true);
  }


  // Kakutei
  if (isKakutei(c, g)) {
    outP = MemPtrNew(16);
    // close dynamic completion
    DComplEnd(g);

    StrCopy(insertStr, g->kanaP);
    StrCat(insertStr, g->okuriP);

    KanaeConvert(outP, nullChr, g);
    StrCat(insertStr, outP);
    MemPtrFree(outP);

    g->candNum = g->numOfCand = 0;
    g->candsOffset = g->currCandOffset = g->okuriC = 0;
    g->userCandsOffset = 0;
    ManaeSetMode(c, g);
    //    KanjiEnd(g);
    return(true);
  }

  // Hankan
  if (isHenkan(c, g)) {
    StrCopy(showStr, g->kanaP);
    //    KanaeConvert(insertStr, c, g);
    KanaeConvert(insertStr, nullChr, g);
    StrCat(showStr, insertStr);
    //    DmWrite(g->kanaP, 0, showStr, StrLen(showStr) + 1);
    mystrncpy(g->kanaP, showStr, StrLen(showStr) + 1);
    insertStr[0] = nullChr;
    StrCopy(showStr, KOHOCHR);
    // close dynamic completion
    DComplEnd(g);

    if (ManaeGetCand2(showStr + StrLen(KOHOCHR), +1, g)){
      g->kanjiMode = HENKAN;
    } else {
      g->kanjiMode = KANJI;
      g->candNum = 0;
      g->numOfCand = 0;
      g->candsOffset = 0;
      g->userCandsOffset = 0;
      g->currCandOffset = 0;
      StrCopy(showStr, HENKANCHR);
      StrCat(showStr, g->kanaP);
      if (g->okuriP[0] != nullChr) {
	StrCat(showStr, "*");
	StrCat(showStr, g->okuriP);
      }
    }
    return(true);
  }

  // Okuri
  if (isupper(c)){
    if (g->kanaP[0] != nullChr) {
      DComplEnd(g);
      return(ManaeKanjiOkuriStart(c, insertStr, showStr, g));
    }
  }

  // Okuri (Jog)
  if (isJogUp(g->event->data.keyDown.chr)) {
    if (g->kanaP[0] != nullChr) {
      DComplEnd(g);
      return(ManaeKanjiOkuriStartJog(insertStr, showStr, g));
    }
  }    

  if (c == backspaceChr) {
    if ((g->okuriC != nullChr) || (g->okuriP[0] != nullChr)) {
      g->okuriC = nullChr;
      //      if (DmSet(g->okuriP, 0, 4, 0))  // clear okuri buffer
      //	ErrFatalDisplayIf(true, "Cannot clear okuri buffer");
      *(g->okuriP) = nullChr;
      StrCopy(showStr, HENKANCHR);
      StrCat(showStr, g->kanaP);
      StrCat(showStr, insertStr);
      insertStr[0] = nullChr;
      return(true);
    }
    if (KanaeConvert(insertStr, c, g)) {
      StrCopy(showStr, HENKANCHR);
      StrCat(showStr, g->kanaP);
      StrCat(showStr, insertStr);
      insertStr[0] = nullChr;
      return(true);
    } 
    kanaLen = StrLen(g->kanaP);
    kanaLen = ((kanaLen -= 2) < 0) ? kanaLen = 0 : kanaLen;
    //    DmSet(g->kanaP, kanaLen, 2, nullChr);
    *(g->kanaP + kanaLen) = nullChr;
    StrCopy(showStr, HENKANCHR);
    StrCat(showStr, g->kanaP);
    return(true);
  }

  outP = MemPtrNew(16);
  if (KanaeConvert(outP, c, g)) {
    StrCopy(showStr, HENKANCHR);
    StrCat(showStr, g->kanaP);

    if ((StrLen(g->kanaP) + StrLen(g->okuriP))< (KANALEN - 8)) {
      // check strlen
      StrCat(showStr, g->okuriP);
      //      DmSet(g->okuriP, 0, 2, nullChr);
      *(g->okuriP) = nullChr;
    }

    if (StrLen(g->kanaP) < (KANALEN - 8)) { // check strlen
      StrCat(showStr, outP);
    }
    //    DmWrite(g->kanaP, 0, showStr + StrLen(HENKANCHR), 
    //	    StrLen(showStr) - StrLen(HENKANCHR) + 1);
    mystrncpy(g->kanaP, showStr + StrLen(HENKANCHR), 
	      StrLen(showStr) - StrLen(HENKANCHR) + 1);
    StrCat(showStr, &g->consonant);
    if (g->okuriP[0] != nullChr) {
      StrCat(showStr, "*");
      StrCat(showStr, g->okuriP);
    }
    // dynamic completion
    if (g->kanaP[1] != nullChr) {
      DComplGetCands(g->kanaP, g);
      DComplShow(g);
    }
  }
  MemPtrFree(outP);
  StrCopy(showStr, HENKANCHR);
  StrCat(showStr, g->kanaP);
  StrCat(showStr, &g->consonant);
  if (g->okuriP[0] != nullChr) {
    StrCat(showStr, "*");
    StrCat(showStr, g->okuriP);
  }
  return(true);
}

static Boolean ManaeKanjiHenkanMode(Char c, CharPtr insertStr, CharPtr showStr,
				    GlobalPtr g)
{
  DWord page;

  insertStr[0] = showStr[0] = nullChr; 
  FtrGet(CREATOR, FEATURECANDSPAGE, &page);

  if (page == CANDSSELECTEDMASK) {
    //    DmSet(g->formerDrawP, 0, 2, nullChr);
    *(g->formerDrawP) = nullChr;
    StrCopy(insertStr, g->selectedCandP);
    LearnWriteCand(g->selectedCandP, g->kanaP, g->okuriC, g->okuriP, g);
    g->candNum = g->numOfCand = 0;
    g->candsOffset = g->currCandOffset = g->okuriC =0;
    ManaeSetKanaMode(g);
    if (FtrSet(CREATOR, FEATURECANDSPAGE, 0x00)) {
      //      FrmCustomAlert(Alert, "kanji.c", "ManaeKanjiHenkanMode()", 
      //		     "Can't set Feature");
    }
    return(true);
  }

  if ((page == CANDSCANCELEDMASK) || (c == backspaceChr) ||
      (c == 'g' - 'a' + 1)) {
    g->kanjiMode = KANJI;
    g->candNum = 0;
    g->numOfCand = 0;
    g->candsOffset = 0;
    g->currCandOffset = 0;
    StrCopy(showStr, HENKANCHR);
    StrCat(showStr, g->kanaP);
    //    DmWrite(g->kanaP, 0, showStr + StrLen(HENKANCHR), 
    //	    StrLen(showStr) - StrLen(HENKANCHR) + 1);
    mystrncpy(g->kanaP, showStr + StrLen(HENKANCHR), 
	      StrLen(showStr) - StrLen(HENKANCHR) + 1);
    //    DmSet(g->okuriP, 0, 2, nullChr);
    *(g->okuriP) = nullChr;
    g->okuriC =0;
    if (FtrSet(CREATOR, FEATURECANDSPAGE, 0x00)) {
      //      FrmCustomAlert(Alert, "kanji.c", "ManaeKanjiHenkanMode()", 
      //		     "Can't set Feature");
    }
    return(true);
  }

  //
  // kakutei
  //
  if (isKakutei(c, g)) {
    //    DmSet(g->formerDrawP, 0, 2, nullChr);
    *(g->formerDrawP) = nullChr;
    // close dynamic completion
    DComplEnd(g); // do nothing.
    if (! (ManaeGetCand2(insertStr, 0, g))) {
      StrCopy(insertStr, g->kanaP);
    }
    LearnWriteCand(insertStr, g->kanaP, g->okuriC, g->okuriP, g);
    g->candNum = g->numOfCand = 0;
    g->candsOffset = g->currCandOffset = g->okuriC =0;
    ManaeSetMode(c, g);
    //    KanjiEnd(g);
    return(true);
  }

  //
  // henkan
  //
  if (isHenkan(c, g)) {
    DWord popup;

    //    FtrGet(CREATOR, FEATURECANDSPOPUP, &popup);
    popup = g->popup;
    popup = (popup > 8) ? 0xffff : popup;
    g->candsFrmFlg = false;
    if (g->candNum == popup) { // Open Cands Form
      g->complFlag = 0;
      g->candsFrmFlg = true;
      if (FtrSet(CREATOR, FEATURECANDSPAGE, 0x1000)) {
	//	FrmCustomAlert(Alert, "kanji.c", "ManaeKanjiHenkanMode()", 
	//		       "Can't set Feature");
      }
      return(true);
    }
    StrCopy(showStr, KOHOCHR);
    // close dynamic completion
    DComplEnd(g);
    if (ManaeGetCand2(showStr + StrLen(KOHOCHR), +1, g)) {
      g->kanjiMode = HENKAN;
      return(true);
    } else {
      // no cand
      g->kanjiMode = KANJI;
      g->candNum = 0;
      g->numOfCand = 0;
      g->candsOffset = 0;
      g->userCandsOffset = 0;
      g->currCandOffset = 0;
      StrCopy(showStr, HENKANCHR);
      StrCat(showStr, g->kanaP);
      if (g->okuriP[0] != nullChr) {
	StrCat(showStr, "*");
	StrCat(showStr, g->okuriP);
      }
      return(true);
    }
    return(true);
  }

  if (isPrev(c, g)) {
    StrCopy(showStr, KOHOCHR);
    // close dynamic completion
    DComplEnd(g);
    if (ManaeGetCand2(showStr + StrLen(KOHOCHR), -1, g)) {
      g->kanjiMode = HENKAN;
      return(true);
    } else {
      g->kanjiMode = KANJI;
      g->candNum = 0;
      g->numOfCand = 0;
      g->candsOffset = 0;
      g->currCandOffset = 0;
      StrCopy(showStr, HENKANCHR);
      StrCat(showStr, g->kanaP);
      if (g->okuriP[0] != nullChr) {
	StrCat(showStr, "*");
	StrCat(showStr, g->okuriP);
      }
    }
    return(true);
  }

  // jog press --- do nothing
  if ((g->event->data.keyDown.chr >= vchrSonyMin) &&
      (g->event->data.keyDown.chr <= vchrSonyMax)) {
    StrCopy(showStr, KOHOCHR);
    // close dynamic completion
    DComplEnd(g);
    if (ManaeGetCand2(showStr + StrLen(KOHOCHR), 0, g)) {
      g->kanjiMode = HENKAN;
      return(true);
    }
    return(false);
  }
    
  // other char
  g->handled = false;
  // close dynamic completion
  DComplEnd(g);
  // insert a currect candidate.
  if (ManaeGetCand2(insertStr, 0, g) == true) {
    LearnWriteCand(insertStr, g->kanaP, g->okuriC, g->okuriP, g);
  }
  g->candNum = g->numOfCand = 0;
  g->candsOffset = g->currCandOffset = g->okuriC = 0;
  ManaeSetKanaMode(g);
  return(true);
}

static Boolean ManaeKanjiHandleChar(Char c, CharPtr insertStr, CharPtr showStr,
				    GlobalPtr g)
{

  insertStr[0] = showStr[0] = nullChr;

  switch(g->kanjiMode) {
  case KANJI:
    return(ManaeKanjiKanjiMode(c, insertStr, showStr, g));
    break;

  case OKURIIN:
    return(ManaeKanjiOkuriMode(c, insertStr, showStr, g));
    break;

  case HENKAN:
    return(ManaeKanjiHenkanMode(c, insertStr, showStr, g));
    break;
   
  default:
    FrmCustomAlert(Alert, "kanji.c", "ManaeKanjiHandleChar", "panic!");
    break;
  }
  return(false);
}

Boolean ManaeKanjiHandleEvent(FieldPtr fld, EventPtr event, GlobalPtr g)
{
  CharPtr showStr, insertStr;
  RectangleType r;

  g->printed = false;

  showStr = MemPtrNew(KANALEN);
  if (showStr == NULL) {
    //    ErrorPrint("manae:ManaeKanjiHandleEvent: fatal error", 0, 0);
    return(false);
  }

  insertStr = MemPtrNew(KANALEN);
  if (insertStr == NULL) {
    if (showStr != NULL) {
      MemPtrFree(showStr);
    }
    //    ErrorPrint("manae:ManaeKanjiHandleEvent: fatal error", 0, 0);
    return(false);
  }

  showStr[0] = nullChr;
  insertStr[0] = nullChr;

  if (event->eType == keyDownEvent) {
    ManaeKanjiHandleChar(event->data.keyDown.chr, insertStr, showStr, g);
  } else {
    // other event handler
    // currently do nothing
    MemPtrFree(showStr);
    MemPtrFree(insertStr);
    return(true); // handled, but do nothing. :-)
  }
  if (g->printed == false) {

    // Erase Printed

    r.topLeft.x = g->kanjiStartX;
    r.topLeft.y = g->kanjiStartY;
    r.extent.x = ((StrLen(g->formerDrawP) + 1) * FntCharsWidth("", 2)) / 2;
    r.extent.y = FntCharHeight();
    InsPtEnable(false);
    WinEraseRectangle (&r, 0);

    if (insertStr[0] != nullChr) {
      InsertToMainField2(insertStr, g);
    }
    InsPtEnable(true);
    if (showStr[0] != nullChr) {
      MyInsPtGetLocation(&(g->insPtX), &(g->insPtY));
      WinDisplayToWindowPt(&(g->insPtX), &(g->insPtY));
      ManaeDrawChars(showStr, StrLen(showStr), g->insPtX, g->insPtY, g);
    }
  }
  //  DmWrite(g->formerDrawP, 0, showStr, StrLen(showStr) + 1);
  mystrncpy(g->formerDrawP, showStr, StrLen(showStr) + 1);
  g->printed = false;
  MemPtrFree(showStr);
  MemPtrFree(insertStr);
  //  ErrNonFatalDisplayIf(true, "ManaeKanjiHandleEvent:done");
  return(true);
}
#endif
