/* 
   manae --- skimple kana MANA Exchanger
   prefs.c.c --- manae's setting preferences module
   Copyright 1998-2002 IWAMA Naozumi
   This file is written in SJIS.
   ̃t@C SJIS ŋLqĂ܂B
*/

#include <PalmOS.h>
#include "manae.h"
#include "id.h"
#include "myfunc.h"

// init.c
GlobalPtr ManaeStart(void);
Err ManaeStop(GlobalPtr g);
DmOpenRef ManaeOpenManaeDB();
Err ManaeCreateManaeDB();

static VoidPtr GetObjectPtr(Word objectID)
{
  FormPtr frm;
	
  frm = FrmGetActiveForm();
  return (FrmGetObjectPtr(frm, FrmGetObjectIndex (frm, objectID)));
}

static Err PreferencesApply()
{
  Prefs p;
  DmOpenRef manaeDB;
  VoidHand recH;
  Prefs *recP;
  Err err;

  if ((manaeDB = ManaeOpenManaeDB()) == NULL) {
    ErrDisplay("Sorry. manae cannot run.\nPlease turn off manae.");
    return(DmGetLastErr());
  }
  
  if ((recH = DmGetRecord(manaeDB, MANAEPREFSINDEX))
      == NULL) {
    ErrDisplay("Sorry. manae cannot run.\nPlease turn off manae.");
    return(DmGetLastErr());
  }

  if ((recP = MemHandleLock(recH))
      == NULL) {
    ErrDisplay("Sorry. manae cannot run.\nPlease turn off manae.");
    return(ERR_1);
  }
  
  p.mode = LstGetSelection(GetObjectPtr(ID_PREFS_DEF_LIST));
  p.guiMode = LstGetSelection(GetObjectPtr(ID_PREFS_GUI_LIST));
  p.popup = LstGetSelection(GetObjectPtr(ID_PREFS_POP_LIST));
  p.nonSkkMode =
    (Boolean)CtlGetValue(GetObjectPtr(ID_PREFS_NON_SKK_CHECKBOX));
  p.autoInsertion = (Boolean)
    CtlGetValue(GetObjectPtr(ID_PREFS_AUTO_INSERTION_CHECKBOX));
  p.thumbTypeMode =
    (Boolean)CtlGetValue(GetObjectPtr(ID_PREFS_THUMB_TYPE_CHECKBOX));
  p.dynamicCompletion = (Boolean)
    CtlGetValue(GetObjectPtr(ID_PREFS_D_COMPL_CHECKBOX));
  p.debug = LstGetSelection(GetObjectPtr(ID_PREFS_DEBUG_LIST));

  p.henkan = recP->henkan;
  p.kakutei = recP->kakutei;
  p.alpha2HiraC = recP->alpha2HiraC;
  p.hira2AlphaC = recP->hira2AlphaC;
  p.hira2KataC = recP->hira2KataC;
  p.hira2ZenC = recP->hira2ZenC;
  p.kata2AlphaC = recP->kata2AlphaC;
  p.kata2HiraC = recP->kata2HiraC;
  p.kata2ZenC = recP->kata2ZenC;
  p.zen2HiraC = recP->zen2HiraC;
  
  StrNCopy(&(p.kuten), &(recP->kuten), 3);
  StrNCopy(&(p.touten), &(recP->touten), 3);

  if (DmWrite(recP, 0, &p, sizeof(Prefs)) != errNone) {
    ErrDisplay("Sorry. manae cannot run.\nPlease turn off manae.");
  }
  
  if (MemHandleUnlock(recH) != 0) {
    ErrDisplay("Sorry. manae cannot run.\nPlease turn off manae.");
  }

  if (DmReleaseRecord(manaeDB, MANAEPREFSINDEX, true) != 0) {
    ErrDisplay("Sorry. manae cannot run.\nPlease turn off manae.");
  }

  if ((err = DmCloseDatabase(manaeDB)) != errNone) {
    ErrDisplay("Sorry. manae cannot run.\nPlease turn off manae.");
    return(err);
  }
  return(errNone);
}


static Boolean PreferencesInit()
{
  DmOpenRef manaeDB;
  VoidHand recH;
  Prefs *recP;
  Err err;
  CharPtr label;
  ListPtr lst;
  ControlPtr ctl;
  Byte itemNum;
  Boolean flag;

  // If manae is running, stop manae. 
  {
    GlobalPtr g;

    if (FtrGet(CREATOR, FEATUREGLOBAL, (DWordPtr)&g) == 0) {
      // The feature exsists.
      //      ErrDisplay("?");
      ManaeStop(g);
    }
  }

  // Get a preferences record's pointer.

  // check manae DB version
  if (MyDmGetDatabaseVersionByTypeCreator(MANAEDBTYPE, CREATOR) <
      DBVERSION) {
    // if there is no manae DB, return 0. 
    if (MyDmDeleteDatabaseByTypeCreator(MANAEDBTYPE, CREATOR) == 0) {
      WinDrawChars("manae deleted manaeDB", 
		   StrLen("manae deleted manaeDB"), 0, 0);
    }
  }

  if ((manaeDB = ManaeOpenManaeDB()) == NULL) {
    if ((err = DmGetLastErr()) == dmErrCantFind) {
      // If there is not a manae db, create it.
      //      ErrDisplay("dmErrCantFind.");
      if ((err = ManaeCreateManaeDB()) != errNone) {
	// Cannot create manae DB.
	ErrDisplay("Cannot create a manae DB.");
	return(err);
      }
      if ((manaeDB = ManaeOpenManaeDB()) == NULL) {
	ErrDisplay("Cannot open manae DB.");
	return(DmGetLastErr());
      }
    } else {
      ErrDisplay("Sorry. manae cannot run.\nPlease turn off manae.");
      return(err);
    }
  }
  
  if ((recH = DmQueryRecord(manaeDB, MANAEPREFSINDEX))
      == NULL) {
    ErrDisplay("Sorry. manae cannot run.\nPlease turn off manae.");
    return(DmGetLastErr());
  }

  if ((recP = MemHandleLock(recH))
      == NULL) {
    ErrDisplay("Sorry. manae cannot run.\nPlease turn off manae.");
    return(ERR_1);
  }

  // Mode Display
  lst = GetObjectPtr(ID_PREFS_GUI_LIST);
  ctl = GetObjectPtr(ID_PREFS_GUI_TRIGGER);
  itemNum = recP->guiMode;
  label = LstGetSelectionText(lst, itemNum);
  CtlSetLabel (ctl, label);
  LstSetSelection (lst, itemNum);

  // Set default mode.
  itemNum = recP->mode;
  lst = GetObjectPtr(ID_PREFS_DEF_LIST);
  ctl = GetObjectPtr(ID_PREFS_DEF_TRIGGER);
  label = LstGetSelectionText(lst, itemNum);
  CtlSetLabel(ctl, label);
  LstSetSelection(lst, itemNum);

  // Candidates list Popup
  itemNum = recP->popup;
  lst = GetObjectPtr(ID_PREFS_POP_LIST);
  ctl = GetObjectPtr(ID_PREFS_POP_TRIGGER);
  label = LstGetSelectionText(lst, itemNum);
  CtlSetLabel(ctl, label);
  LstSetSelection(lst, itemNum);

  // Debug Level
  itemNum = recP->debug;
  lst = GetObjectPtr(ID_PREFS_DEBUG_LIST);
  ctl = GetObjectPtr(ID_PREFS_DEBUG_TRIGGER);
  label = LstGetSelectionText(lst, itemNum);
  CtlSetLabel(ctl, label);
  LstSetSelection(lst, itemNum);

  // Non-SKK mode
  ctl = GetObjectPtr(ID_PREFS_NON_SKK_CHECKBOX);
  flag = recP->nonSkkMode;
  CtlSetValue(ctl, (short)flag);

  // Auto Kana Insertion
  ctl = GetObjectPtr(ID_PREFS_AUTO_INSERTION_CHECKBOX);
  flag = recP->autoInsertion;
  CtlSetValue(ctl, (short)flag);

  // Thumb Type mode
  ctl = GetObjectPtr(ID_PREFS_THUMB_TYPE_CHECKBOX);
  flag = recP->thumbTypeMode;
  CtlSetValue(ctl, (short)flag);

  // Disable Dynamic Completion
  ctl = GetObjectPtr(ID_PREFS_D_COMPL_CHECKBOX);
  flag = recP->dynamicCompletion;
  CtlSetValue(ctl, (short)flag);

  // Close the rec and the db.

  if (MemHandleUnlock(recH) != 0) {
    ErrDisplay("Sorry. manae cannot run.\nPlease turn off manae.");
  }

  if ((err = DmCloseDatabase(manaeDB)) != errNone) {
    ErrDisplay("Sorry. manae cannot run.\nPlease turn off manae.");
    return(err);
  }

  return(true);
}

Boolean PrefsHandleEvent(EventPtr event)
{
  Boolean handled = false;
  FormPtr frm;

  if (event->eType == ctlSelectEvent)
    {
      switch (event->data.ctlSelect.controlID)
	{
	case ID_PREFS_BUTTON_DONE:
	  PreferencesApply();
	  FrmGotoForm(9000);
	  handled = true;
	  break;
	  
	case ID_PREFS_BUTTON_INIT:
	  FrmReturnToForm(NULL);
	  handled = true;
	  break;
	  
	}
    }
  
  else if (event->eType == frmOpenEvent)
    {
      frm = FrmGetActiveForm();
      PreferencesInit();
      FrmDrawForm(frm);
      handled = true;
    }
  else if (event->eType == frmCloseEvent)
    {
      handled = false;
    }
  else if (event->eType == appStopEvent)
    {
      handled = false;
    }
  
  return (handled);
}

